import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Write a description of class Rakete here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Rakete extends Animal
{
    private boolean inBewegung = false;
    private int anzahlTreffer = 0;
    private Ballon zielobjekt;
    
    /**
     * Act - do whatever the Rakete wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    public void act() 
    {
        if (inBewegung == false) {
            tastaturAbfrage();
        } else {
            fliegeNachOben();
        }
        
    }    
    
    /**
     * Methode zur Steuerung der Tastaturabfrage. Der Anwender kann die
     * Rakete mit den Pfeiltasten nach links und rechts bewegen und mit der Leertaste
     * kann er die Rakete abschießen.
     */
    public void tastaturAbfrage()
    {
        // Rakete abschiessen
        if (Greenfoot.isKeyDown("space")) {
            inBewegung = true;
        }
        
        // Rakete links/rechts bewegen
        if (Greenfoot.isKeyDown("left")) {
            setLocation(getX()-10,getY());
        }
        if (Greenfoot.isKeyDown("right")) {
            setLocation(getX()+10,getY());
        }
        
        // Cheatmodus
        if (Greenfoot.isKeyDown("c")) {
            turnTowards(zielobjekt.getX(),zielobjekt.getY());
        }
    }
    
    /**
     * Methode für die Bewegung nach oben. Ist die Rakete abgeschossen worden,
     * so fliegt sie nach oben, bis sie entweder am oberen Rand ankommt oder auf
     * das Zielobjekt (den Ballon) getroffen ist. Im letzteren Fall werden die Punkte
     * hochgezählt und bei 10 erreichten Punkten die Anwendung gestoppt.
     */
    public void fliegeNachOben()
    {
        move(5);            
        if (atWorldEdge() == true ) {
            inBewegung = false;
            setLocation(getX(),350);
        } else if (canSee(Ballon.class) == true) {
            inBewegung = false;
            setLocation(Greenfoot.getRandomNumber(400)+100,350);
            anzahlTreffer++;
            zielobjekt.wechsleBild();
            if (anzahlTreffer == 10) {
                Greenfoot.stop();
            }
        }        
    }
    
   
    /**
     * Methode ermöglicht das Kennenlernen des Zielobjekts.
     */
    public void lerneBallonKennen(Ballon b)
    {
        zielobjekt = b;
    }
        
}
